#include <sys/types.h>
#include <sys/socket.h> 
#include <sys/uio.h>
/*
 * Following libraries is required for gethostbyname and htons.
 * Implies compilation with  -lnsl
 */
#include <netinet/in.h>
#include <inttypes.h>
#include <arpa/inet.h>
#include <netdb.h>

/*
 * Following library is required for write and sentto
 */
#include <unistd.h>
/*
 * Following library is required for isdigit
 */
#include <ctype.h>
/*
 * Following library is required for signal
 */
#include <signal.h>
#include <stdio.h>
#include <string.h> 

#include "debug.h"
#ifdef MXX
#include "mutant.h"
#endif
#include "coverage.h"

/*
 * The main datatype record for the conference protocol program
 */

#define MAXNAME     50 
#define MAXUSERS    10 
#define MAXMUTANTS    100
#define MAXBUCKETS    100

#define STOP		0
#define JOIN		1
#define LEAVE		2
#define	ANSWER		3
#define	DATA		4

#define MAXPDUSIZE	1500
#define MAXNICKNAME	10
#define MAXCONFERENCE	10
#define JOINPDUSIZE	1+MAXNICKNAME+MAXCONFERENCE
/* #define DATAPDUSIZE 1+1+PDU[1] */
#define LEAVEPDUSIZE	1+MAXNICKNAME+MAXCONFERENCE
#define ANSWERPDUSIZE	1+MAXNICKNAME+MAXCONFERENCE

typedef char	nickname_Type[MAXNICKNAME];

struct Cache_Type {
	int	free;
	int	sort;
	struct sockaddr_in address;
	char	buf[MAXPDUSIZE];
	int	sizeofbuf;
};

struct Mutant_Type {
	int	id;
	int	Steps;
	int	Enable;
	int	Disable;
};

struct ConfProtData_Type {
	/* 
	  *Connection to  user.
	  */
	int	stdinhandle;
	int	stdouthandle;

	/*
	  * Connection to network (UDP).
	  */
	int	nusers;
	int	sockhandle;
	int	availLocalSocket;
	struct sockaddr_in socketaddress[MAXUSERS];
	int clientids[MAXUSERS];
	int p2cid[MAXUSERS];

	/*
	  * options
	  */
	int	gui;
	int	debug;
	/*
	  * mutants
	  */
#ifdef MX1
	int	nmutants;
	struct Mutant_Type mutant[MAXMUTANTS+1];
#endif
	int	nbuckets;
	struct Cache_Type Cache[MAXBUCKETS];

	/*
	  * Current conference
	  */
	int	active;
	char	nickname[MAXNICKNAME];
	char	conference[MAXCONFERENCE];

	/*
	  * Partner set datatype
	  */
	int	npartners;
	struct sockaddr_in partner[MAXUSERS+1];
	nickname_Type partnernickname[MAXUSERS];

};

typedef struct ConfProtData_Type *ConfProtData;
struct ConfProtData_Type CPV;

