#include "datatype.h"
#include "confprot.h"
#include "processObservation.h"


static int	ConferenceActive(char *pdu, ConfProtData CPD);
static int	Partner(ConfProtData CPD);
static int	PotentialPartner(ConfProtData CPD);

int	processObservation(ConfProtData CPD)
{
	int	result = 0;
	char	buf[MAXPDUSIZE+1];
	char	*pdu=&buf[1];
	char	cdu[MAXPDUSIZE+MAXNICKNAME];
	int	cid = 0;

	MarkCoverage();
	result = recv(CPD->sockhandle, (char *)buf , MAXPDUSIZE+1, 0);

#ifndef M09
	if ((result < 0)) {	
		MarkCoverage();
		/*
	    * Error in recvfrom operation!
	    */
#endif
		return(-30);
#ifndef M09
	}
	MarkCoverage();
#endif
	if ((result == 0)) {
		MarkCoverage();
		WriteMSG("EOF detected!\n");
		close(CPD->sockhandle);
		return(-31);
	}
	MarkCoverage();
{
	int i;
	
/*	WriteMSG("Read from server connection %d bytes\n",result);
	for (i=0; i<result; i++) {
	  fprintf(stderr, "%02X", buf[i]);
	}
	fprintf(stderr,"\n");
	fflush(stderr);
*/
}		

/*
 *	The source address is always the server address, this is not the address 
 *	that we want. The src is determined with 
 *	the client id.
 */

	cid = 0;
	while ((cid < CPD->nusers) && (buf[0]!=CPD->clientids[cid])) cid++;
	if (cid >= CPD->nusers) {
		MarkCoverage();
		/* WriteMSG("unknown source address! - cid = %d\n", cid);*/
		return(0);
	}
/*	WriteMSG("message from - cid = %d\n", cid);
	WriteMSG("pdu[0] = %d\n", pdu[0]);
	WriteMSG("pdu[1] = %d\n", pdu[1]);
*/
	memcpy(&CPD->partner[CPD->npartners], &CPD->socketaddress[cid], sizeof(struct sockaddr_in));
	CPD->p2cid[CPD->npartners] = cid;

#ifndef M52
	if ((!CPD->active)) {
		MarkCoverage();
#endif
		WriteMSG("No conference active!\n");
		return(0);
#ifndef M52
	}
	MarkCoverage();
#endif

#ifdef M53
	pdu[0] = '\255'; /* Force unknow pdu packet */
#endif

	/*
	  * switch over pdu type field
	  */
	switch (pdu[0]) {
	case JOIN:
		 {
			int	p = 0;

			MarkCoverage();
#ifdef M13
			break;
#endif

#ifndef M37
			if (!ConferenceActive(pdu, CPD)) {
			MarkCoverage();
				break;
			}
		MarkCoverage();
#endif
#ifndef M36
			if ((p = PotentialPartner(CPD)) >= CPD->nusers) {
			MarkCoverage();
				break;
			}
		MarkCoverage();
#endif
#ifndef M35
			if ((p = Partner(CPD)) >= CPD->npartners) {
				MarkCoverage();
#ifndef M27
				if ((p >= MAXUSERS)) {
					MarkCoverage();
#endif
					break; /* to many users... */
#ifndef M27
				}
				MarkCoverage();
#endif

				/*
				* Add ruser to partner set...
				* - Get nickname...
				* - extend partner (socketaddr_in) table
				*/
				memcpy(CPD->partnernickname[CPD->npartners], &pdu[1], MAXNICKNAME);
				CPD->npartners++;
			}
			MarkCoverage();
#endif
			/*
			* Send ANSWER pdu back to source...
			*/
			pdu[0] = (char)ANSWER;
			memcpy(&pdu[1], CPD->nickname, MAXNICKNAME);
			/* conference is already inorder */

#ifdef M17
			break;
#endif
			/* NOTE! that p == CPD->npartners-1 */
			transmit(CPD, pdu, ANSWERPDUSIZE, ANSWER, cid);
#ifdef M50
			transmit(CPD, pdu, ANSWERPDUSIZE, ANSWER, cid);
#endif
			break;
		}

	case DATA:
		 {
			int	p = 0;

			MarkCoverage();
#ifdef M14
			break;
#endif

#ifndef M34
			if ((p = Partner(CPD)) < CPD->npartners) {
				MarkCoverage();
#ifdef M45
				/*
				* Send the message also back to the remote user
				*/
				transmit(CPD, pdu, 1 + 1 + pdu[1], DATA, cid);
#endif
				/*
				* p is partner
				* - deliver message to user
				*/
				/* cdu[0] = pdu[0]; */
				cdu[0] = ANSWER; /* 3 */
				memcpy(&cdu[1], CPD->partnernickname[p], MAXNICKNAME);
				memcpy(&cdu[1+MAXNICKNAME], &pdu[1], 1 + pdu[1]);

#ifdef M28
				break;
#endif
				write(CPD->stdouthandle, cdu, MAXNICKNAME + 2 + cdu[MAXNICKNAME+1]);

#ifndef M42
				break;
#endif
			}
		MarkCoverage();
#endif
			/*
			      * Send JOIN pdu back to source...
			      */
			pdu[0] = (char)JOIN;
			memcpy(&pdu[1], CPD->nickname, MAXNICKNAME);
			memcpy(&pdu[1+MAXNICKNAME], CPD->conference, MAXCONFERENCE);

#ifdef M18
			break;
#endif
			/* NOTE! that p == CPD->npartners */
			transmit(CPD, pdu, JOINPDUSIZE, JOIN, cid);
#ifdef M51
			transmit(CPD, pdu, JOINPDUSIZE, JOIN, cid);
#endif

			break;
		}

	case ANSWER:
		 {
			int	p = 0;

			MarkCoverage();
#ifdef M15
			break;
#endif

#ifndef M33
			if (!ConferenceActive(pdu, CPD)) {
				MarkCoverage();
				break;
			}
			MarkCoverage();
#endif
#ifndef M32
			if ((p = PotentialPartner(CPD)) >= CPD->nusers) {
				MarkCoverage();
				break;
			}
			MarkCoverage();
#endif
#ifndef M31
			if ((p = Partner(CPD)) < CPD->npartners) {
				MarkCoverage();
				break;
			}
			MarkCoverage();
#endif

#ifndef M19
			if ((p >= MAXUSERS)) {
				MarkCoverage();
#endif
				break; /* to many users... */
#ifndef M19
			}
			MarkCoverage();
#endif

			/*
			* Add ruser to partner set..
			* - Get partners nickname...
			* - extend partner (socketaddr_in) table
			*/
			memcpy(CPD->partnernickname[CPD->npartners], &pdu[1], MAXNICKNAME);
			CPD->npartners++;

			break;
		}

	case LEAVE:
		 {
			int	p = 0;

			MarkCoverage();
#ifdef M16
			break;
#endif
#ifndef M30
			if (!ConferenceActive(pdu, CPD)) {
				MarkCoverage();
				break;
			}
			MarkCoverage();
#endif
#ifndef M29
			if ((p = Partner(CPD)) >= CPD->npartners) {
				MarkCoverage();
				break;
			}
			MarkCoverage();
#endif

#ifdef M20
			break;
#endif
			/* remove p from partnerset */
			if (p + 1 == CPD->npartners) {
				MarkCoverage();
				CPD->npartners--;
				break;
			}
			MarkCoverage();

			CPD->npartners--;
			memcpy(&CPD->partner[p], &CPD->partner[CPD->npartners], sizeof(struct sockaddr_in ));
			memcpy(CPD->partnernickname[p], CPD->partnernickname[CPD->npartners], MAXNICKNAME);
			CPD->p2cid[p] = CPD->p2cid[CPD->npartners];

#ifdef DEBUG
			/* clear the freed positon - just to be sure! */
			memset(&CPD->partner[CPD->npartners+1], 0, sizeof(struct sockaddr_in ));
			memset(CPD->partnernickname[CPD->npartners+1], 0, MAXNICKNAME);
#endif
			break;
		}

	default:
		{
			MarkCoverage();
			WriteMSG("Unknown pdu received!\n");
			break;
		}
	}

	MarkCoverage();
	return(0);
}


static int	ConferenceActive(char *pdu, ConfProtData CPD)
{
	MarkCoverage();
	return(memcmp(CPD->conference, &pdu[MAXNICKNAME+1], MAXCONFERENCE) == 0);
}


static int	Partner(ConfProtData CPD)
{
	char	buf1[20];
	char	buf2[20];
	int	p = 0;

	MarkCoverage();
	p = 0;
	strcpy((char *) & buf2, inet_ntoa(CPD->partner[CPD->npartners].sin_addr));
	strcpy((char *) & buf1, inet_ntoa(CPD->partner[p].sin_addr));
	while ( (p < CPD->npartners) &&  (  (strcmp(buf1, buf2) != 0) ||  (CPD->partner[p].sin_port != CPD->partner[CPD->npartners].sin_port))) {
		MarkCoverage();
		p++;
		strcpy((char *) & buf1, inet_ntoa(CPD->partner[p].sin_addr));
	}
	MarkCoverage();
	return(p);
}


static int	PotentialPartner(ConfProtData CPD)
{
	char	buf1[20];
	char	buf2[20];
	int	p = 1;
	/*
	* Check if rusers is potential partner...
	*/
	MarkCoverage();
	p = 2;
	strcpy((char *) & buf2, inet_ntoa(CPD->partner[CPD->npartners].sin_addr));
	strcpy((char *) & buf1, inet_ntoa(CPD->socketaddress[p].sin_addr));
/*	WriteMSG("pp remote %s:%d\n", buf2, CPD->partner[CPD->npartners].sin_port);
	WriteMSG("pp local[%d] %s:%d\n", p, buf1, CPD->socketaddress[p].sin_port);
*/
	while ( (p < CPD->nusers) &&  (  (strcmp(buf1, buf2) != 0) ||  (CPD->socketaddress[p].sin_port != CPD->partner[CPD->npartners].sin_port))) {
		MarkCoverage();
		p++;
		strcpy((char *) & buf1, inet_ntoa(CPD->socketaddress[p].sin_addr));
/*	WriteMSG("pp local[%d] %s:%d\n", p, buf1, CPD->socketaddress[p].sin_port);
*/
	}
	MarkCoverage();
	return(p);
}


