#include <stdarg.h>
#include "datatype.h"  

#ifdef DEBUG
extern ConfProtData CPD; /* see confprot.c */
#endif

void	WriteMSG(char *fmt, ... )
{
	va_list args;

	va_start(args, fmt);
	(void)vfprintf(stderr, fmt, args);
	va_end(args);
	fflush(stderr);
}


#ifdef DEBUG
void	Debug(char *fmt, ... )
{
	va_list args;

	va_start(args, fmt);
	(void)fprintf(stderr, "Debug: ");
	(void)vfprintf(stderr, fmt, args);
	(void)fprintf(stderr, "\n");
	va_end(args);
	fflush(stderr);
}


int	decode(int len, char *dst, const char *src)
{
	int	i = 0;

	for (i = 0; i < len; i++) {
		if (src[i] == '\0')
			dst[i] = '.';
			else
			dst[i] = src[i];
	}
	dst[i] = '\0';
	return 0;
}


int	showpartnertable()
{
	int	i;
	for (i = 0; i < CPD->npartners; i++) {
		 {
			char	buf[MAXNICKNAME+1];
			decode(MAXNICKNAME, buf, CPD->partnernickname[i]);
			Debug(1, "nickname - (%d : %s)", i, buf);
		}

	}
	return(0);
}


#endif
