#include "datatype.h"
#include "confprot.h"
#include "processObservation.h"


static int	ConferenceActive(char *pdu, ConfProtData CPD);
static int	Partner(ConfProtData CPD);
static int	PotentialPartner(ConfProtData CPD);

int	AcceptConnection(ConfProtData CPD)
{
	int	result = 0;
	int	size = 0;
	char	buf[MAXPDUSIZE+1];
	char	*pdu=&buf[1];
	char	cdu[MAXPDUSIZE+MAXNICKNAME];
	int	cid = 0;
	int	p = 0;

	MarkCoverage();
	size = sizeof(struct sockaddr_in );
	result = accept(CPD->sockhandle, (struct sockaddr *) & CPD->partner[CPD->npartners], &size);

/*	WriteMSG("Incomming connection...!\n"); */
#ifndef M09
	if ((result < 0)) {	
		MarkCoverage();
		/*
	    * Error in accept operation!
	    */
#endif
		return(-30);
#ifndef M09
	}
	MarkCoverage();
#endif

	if ((p = PotentialPartner(CPD)) >= CPD->nusers) {
		MarkCoverage();
		WriteMSG("Connection is not a ppartner.%d.!\n",p);
		close(result);  /* close connection */
	}

/*	WriteMSG("ppartner idx=%d id=%d ss=%d found...!\n", p, 
		CPD->clientref2id[p], result); */
	CPD->clientsd[p] = result; 

	MarkCoverage();
	return(0);
}

int	ForwardMessage(ConfProtData CPD, char srccid)
{
	int	size = 0;
	char	buf1[20];
	int	port=0;
	char	buf[MAXPDUSIZE+1];
	char	*pdu=buf;
	char	dstcid = 0;
	int	id = 0;
	int msgsize=0;

	MarkCoverage();
	
/*
 *  With TCP we have to take into account take data is stream oriented and
 *  can be buffered. This means that we can receive several messages at once.
 */
	size = recv(CPD->clientsd[srccid], (char *)buf , MAXPDUSIZE+1, 0);

	if ((size < 0)) {	
		WriteMSG("EOF received from user %d\n", srccid);
		MarkCoverage();
		close(CPD->clientsd[srccid]);
		CPD->clientsd[srccid] = -1;
		return(0);
	}
	MarkCoverage();
	strcpy((char *) & buf1, inet_ntoa(CPD->socketaddress[srccid].sin_addr));
	port = CPD->socketaddress[srccid].sin_port;
	WriteMSG("R %s:%d ", buf1, port, size);
	MarkCoverage();
	if ((size == 0)) {
		MarkCoverage();
		WriteMSG("EOF detected!\n");
		close(CPD->clientsd[srccid]);
		CPD->clientsd[srccid] = -1;
		return(0);
	}
	{
		int i;
		for (i=0; i<size; i++) {
			WriteMSG("%02X",  buf[i]);
		}
		WriteMSG("\n");
	}
	
	while (size>0) {
	/*	
	 *	Determine - the size of the first message! (msgsize)
	 */	
		switch (pdu[1]) {
			case 1:;
			case 2:;
			case 3: { msgsize = 22; break; }
			case 4: { msgsize = 3+pdu[2]; break; }
			default: { msgsize = 0; break; }
		}
		
		if (msgsize > size) {
			WriteMSG("The message is to long...\n");
			return;
		}
	
	/*	
	 *	Determine - the destination addres 
	 */	
		dstcid = 1;
		while ((dstcid < CPD->nusers) && (pdu[0]!=CPD->clientref2id[dstcid])) {
			MarkCoverage();
			dstcid++;
		}
		MarkCoverage();
		if (dstcid >= CPD->nusers) {
			WriteMSG("unknown dest address! - dstid = %d\n", dstcid);
			MarkCoverage();
			return(0); /* unknown dest address! */
		}
		MarkCoverage();

		pdu[0] = CPD->clientref2id[srccid];
		transmit(CPD, pdu, msgsize, 0, dstcid);
		pdu += msgsize;
		size -= msgsize;
	}
	return(0);
}


static int	ConferenceActive(char *pdu, ConfProtData CPD)
{
	MarkCoverage();
	return(memcmp(CPD->conference, &pdu[MAXNICKNAME+1], MAXCONFERENCE) == 0);
}


static int	Partner(ConfProtData CPD)
{
	char	buf1[20];
	char	buf2[20];
	int	p = 0;

	MarkCoverage();
	p = 0;
	strcpy((char *) & buf2, inet_ntoa(CPD->partner[CPD->npartners].sin_addr));
	strcpy((char *) & buf1, inet_ntoa(CPD->partner[p].sin_addr));
	while ( (p < CPD->npartners) &&  (  (strcmp(buf1, buf2) != 0) ||  (CPD->partner[p].sin_port != CPD->partner[CPD->npartners].sin_port))) {
		MarkCoverage();
		p++;
		strcpy((char *) & buf1, inet_ntoa(CPD->partner[p].sin_addr));
	}
	MarkCoverage();
	return(p);
}


static int	PotentialPartner(ConfProtData CPD)
{
	char	buf1[20];
	char	buf2[20];
	int	p = 1;
	/*
	* Check if rusers is potential partner...
	*/
	MarkCoverage();
	p = 1;
	strcpy((char *) & buf2, inet_ntoa(CPD->partner[CPD->npartners].sin_addr));
	strcpy((char *) & buf1, inet_ntoa(CPD->socketaddress[p].sin_addr));

	while ( (p < CPD->nusers) &&  (  (strcmp(buf1, buf2) != 0) ||  (CPD->socketaddress[p].sin_port != CPD->partner[CPD->npartners].sin_port))) {
		MarkCoverage();
		p++;
		strcpy((char *) & buf1, inet_ntoa(CPD->socketaddress[p].sin_addr));
	}
	MarkCoverage();
	return(p);
}


