/******************************************************************/
/* filename: tools.c */
/* version : 1.00  */
/* author  : Jan Feenstra */
/******************************************************************/

#include <stdarg.h>
#include "user.h"

int debug_level=User;
/******************************************************************/

int decodeTitle(char ut1[USERTITLELENGTH], char ut2[USERTITLELENGTH+1]);
int encodeTitle(char ut1[USERTITLELENGTH+1], char ut2[USERTITLELENGTH]);
int writeTitle(char ut1[USERTITLELENGTH]);
int decodeConfid(char ut1[CONFIDLENGTH], char ut2[CONFIDLENGTH+1]);
int encodeConfid( char ut1[CONFIDLENGTH+1], char ut2[CONFIDLENGTH]);
int writeConfid(char ut1[CONFIDLENGTH]);
int decodeData(char len, char data1[DATALENGTH], char data2[DATALENGTH+1]);
int encodeData(char data1[DATALENGTH+1], char *len, char data2[DATALENGTH]);
int writeData(const char data[DATALENGTH]);
/******************************************************************/

int decodeTitle(char ut1[USERTITLELENGTH], char ut2[USERTITLELENGTH+1])
{
 int i,j;

 for (i=0; i<USERTITLELENGTH; i++) /* purecov: inspected */
  if (ut1[i]!='\0') break; /* purecov: inspected */
 if (i!=USERTITLELENGTH) /* purecov: inspected */
 {
  for (j=0;i<USERTITLELENGTH;i++,j++) /* purecov: inspected */
   ut2[j] = ut1[i]; /* purecov: inspected */
 }
 ut2[j] = '\0'; /* purecov: inspected */
 return 0; /* purecov: inspected */
} /* purecov: inspected */
/******************************************************************/

int encodeTitle(char ut1[USERTITLELENGTH+1], char ut2[USERTITLELENGTH])
{
 int i,j;

 i=strlen(ut1); /* purecov: inspected */
 if ( (0<=i) && (i<=USERTITLELENGTH) ) /* purecov: inspected */
 {
  i=USERTITLELENGTH-i; /* purecov: inspected */
  for (j=0; j<i; j++) /* purecov: inspected */
	ut2[j] = '\0'; /* purecov: inspected */
  for (i=0; j<USERTITLELENGTH; j++, i++) /* purecov: inspected */
	ut2[j] = ut1[i]; /* purecov: inspected */
  return(0); /* purecov: inspected */
 }
 else
 {
  Error(Dbg,"The encoding title string is to long..."); /* purecov: inspected */
  return(-1); /* purecov: inspected */
 }
} /* purecov: inspected */
/******************************************************************/

int writeTitle(char ut1[USERTITLELENGTH])
{char buf[USERTITLELENGTH+1];
 int i;
 for (i=0; i<USERTITLELENGTH; i++) /* purecov: inspected */
  if (ut1[i]<=32) buf[i] = '_'; /* purecov: inspected */
  else buf[i] = ut1[i]; /* purecov: inspected */
 buf[i+1] = '\0';  /* purecov: inspected */
 Debug(Dbg,"<%s>\n",buf); /* purecov: inspected */
} /* purecov: inspected */
/******************************************************************/

int decodeConfid(char ut1[CONFIDLENGTH], char ut2[CONFIDLENGTH+1])
{
 int i,j;

 for (i=0; i<CONFIDLENGTH; i++) /* purecov: inspected */
  if (ut1[i]!='\0') break; /* purecov: inspected */
 if (i!=CONFIDLENGTH) /* purecov: inspected */
 {
  for (j=0;i<CONFIDLENGTH;i++,j++) /* purecov: inspected */
   ut2[j] = ut1[i]; /* purecov: inspected */
 }
 ut2[j] = '\0'; /* purecov: inspected */
 return 0; /* purecov: inspected */
} /* purecov: inspected */
/******************************************************************/

int encodeConfid( char ut1[CONFIDLENGTH+1], char ut2[CONFIDLENGTH])
{
 int i,j;
  
 i=strlen(ut1); /* purecov: inspected */
 if ( (0<=i) && (i<=CONFIDLENGTH) ) /* purecov: inspected */
 {
  i=CONFIDLENGTH-i;  /* purecov: inspected */
  for (j=0; j<i; j++) /* purecov: inspected */
   ut2[j] = '\0'; /* purecov: inspected */
  for (i=0; j<CONFIDLENGTH; j++, i++) /* purecov: inspected */
   ut2[j] = ut1[i]; /* purecov: inspected */
  return(0); /* purecov: inspected */
 }
 else
 {
  Error(Dbg,"The encoding confid string is to long..."); /* purecov: inspected */
  return(-1); /* purecov: inspected */
 }
} /* purecov: inspected */
/******************************************************************/

int writeConfid(char ut1[CONFIDLENGTH])
{char buf[CONFIDLENGTH+1];
 int i;
 for (i=0; i<CONFIDLENGTH; i++) /* purecov: inspected */
  if (ut1[i]<=32) buf[i] = '_'; /* purecov: inspected */
  else buf[i] = ut1[i]; /* purecov: inspected */
 buf[i+1] = '\0';  /* purecov: inspected */
 Debug(Dbg,"<%s>\n",buf); /* purecov: inspected */
} /* purecov: inspected */
/******************************************************************/

int decodeData(char len, char data1[DATALENGTH], char data2[DATALENGTH+1])
{
 int i;
 for (i=0; i<len; i++) /* purecov: inspected */
  data2[i] = data1[i]; /* purecov: inspected */
 data2[i]='\0'; /* purecov: inspected */
 return(0); /* purecov: inspected */
} /* purecov: inspected */
/******************************************************************/

int encodeData(char data1[DATALENGTH+1], char *len, char data2[DATALENGTH])
{
 int i;
 for (i=0 ; (data1[i]!='\0') && (i<DATALENGTH) ; i++)  /* purecov: inspected */
  data2[i]=data1[i]; /* purecov: inspected */
 *len = i; /* purecov: inspected */
 return(0); /* purecov: inspected */
} /* purecov: inspected */
/******************************************************************/

int writeData(const char data[DATALENGTH])
{char buf[DATALENGTH+1];
 int i;
 for (i=0; i<CONFIDLENGTH; i++) /* purecov: inspected */
  if (data[i]<=32) buf[i] = '_'; /* purecov: inspected */
  else buf[i] = data[i]; /* purecov: inspected */
 buf[i+1] = '\0';  /* purecov: inspected */
 Debug(Dbg,"<%s>\n",buf); /* purecov: inspected */
} /* purecov: inspected */
/******************************************************************/


void Debug( int level, char *fmt, ... )
{
  va_list args;

  va_start(args, fmt);
  if ((level & debug_level) == level) {
      /* print out prefix of message */
    (void)fprintf(stderr, "Debug: ");
      /* print out remainder of message */
    (void)vfprintf(stderr, fmt, args);
    (void)fprintf(stderr, "\n");
  }
  va_end(args);
  fflush(stderr);
}

void Error( int level, char *fmt, ... )
{
  va_list args;

  va_start(args, fmt); /* purecov: inspected */
  if ((level & debug_level) == level) { /* purecov: inspected */
      /* print out prefix of message */
    (void)fprintf(stderr, "Error: "); /* purecov: inspected */
      /* print out remainder of message */
    (void)vfprintf(stderr, fmt, args); /* purecov: inspected */
    (void)fprintf(stderr, "\n"); /* purecov: inspected */
  }
  va_end(args); /* purecov: inspected */
  fflush(stderr); /* purecov: inspected */
} /* purecov: inspected */
void Warning( int level, char *fmt, ... )
{
  va_list args;

  va_start(args, fmt); /* purecov: inspected */
  if ((level & debug_level) == level) { /* purecov: inspected */
      /* print out prefix of message */
    (void)fprintf(stderr, "Warni: "); /* purecov: inspected */
      /* print out remainder of message */
    (void)vfprintf(stderr, fmt, args); /* purecov: inspected */
    (void)fprintf(stderr, "\n"); /* purecov: inspected */
  }
  va_end(args); /* purecov: inspected */
  fflush(stderr); /* purecov: inspected */
} /* purecov: inspected */

void Msg(int level, char *fmt, ... )
{
  va_list args;

  va_start(args, fmt); /* purecov: inspected */
  if ((level & debug_level) == level) { /* purecov: inspected */
      /* print out prefix of message 
    (void)fprintf(stdout, "Msg  : ");
       print out remainder of message */
    (void)vfprintf(stdout, fmt, args); /* purecov: inspected */
  }
  va_end(args); /* purecov: inspected */
  fflush(stdout); /* purecov: inspected */
} /* purecov: inspected */
void Info(int level, char *fmt, ... )
{
  va_list args;

  va_start(args, fmt);
  if ((level & debug_level) == level) {
      /* print out remainder of message */
    (void)vfprintf(stderr, fmt, args);
  }
  va_end(args);
  fflush(stderr);
}

